﻿#include "TileAtlas.hpp"

TileAtlas TileAtlas::defaultAtlas()
{
	TileAtlas atlas(sf::Vector2u{16, 16}, sf::Vector2u{16, 16}, ASSETS_PATH "/default_tilemap.png");
	return atlas;
}

void TileAtlas::set(uint32_t x, uint32_t y)
{
	if (x >= tile_count.x || y >= tile_count.y) return;
}

TileAtlas::TileAtlas(const sf::Vector2u tile_size, const sf::Vector2u tile_count, const std::filesystem::path& path) :
	tile_size(tile_size), tile_count(tile_count) { load(path); }

TileAtlas::TileAtlas(sf::Vector2u tile_size, sf::Vector2u tile_count) : tile_size(tile_size), tile_count(tile_count)
{
}

void TileAtlas::load(const std::filesystem::path& path) {
	if (!texture.loadFromFile(path))
	{
		throw std::runtime_error("TileAtlas: [Loading] Could not load tilemap -> Fatal");
	}
}

void TileAtlas::draw(sf::RenderTarget& target, sf::RenderStates states) const
{
	// apply the transform
	states.transform *= getTransform();

	// apply the tileset texture
	states.texture = &texture;

	// draw the vertex array
	target.draw(vertices, states);
}